unit UDemo1;

interface

uses
  Windows, Messages, SysUtils, Classes, Graphics, Controls, Forms, Dialogs,
  StdCtrls, TypInfo, F_Lang, Menus, Spin, ExtCtrls, DB, DBTables, DBCtrls,
  Grids, DBGrids, Buttons;

type
  TForm1 = class(TForm)
    Edit1: TEdit;
    Edit2: TEdit;
    Edit3: TEdit;
    MainMenu1: TMainMenu;
    File1: TMenuItem;
    Close1: TMenuItem;
    SpinEdit1: TSpinEdit;
    Label1: TLabel;
    Label2: TLabel;
    Label3: TLabel;
    Memo1: TMemo;
    ColorDialog1: TColorDialog;
    ListBox1: TListBox;
    Button2: TButton;
    Table1: TTable;
    Button3: TButton;
    Button4: TButton;
    Button5: TButton;
    Button6: TButton;
    Button7: TButton;
    Button8: TButton;
    DataSource1: TDataSource;
    DBGrid1: TDBGrid;
    DBNavigator1: TDBNavigator;
    About1: TMenuItem;
    N1: TMenuItem;
    Label5: TLabel;
    Label6: TLabel;
    GroupBox1: TGroupBox;
    RadioButton1: TRadioButton;
    RadioButton2: TRadioButton;
    RadioButton3: TRadioButton;
    RadioButton4: TRadioButton;
    RadioButton5: TRadioButton;
    RadioButton6: TRadioButton;
    RadioButton7: TRadioButton;
    GroupBox2: TGroupBox;
    CheckBox1: TCheckBox;
    CheckBox2: TCheckBox;
    Panel1: TPanel;
    Button10: TButton;
    EditEN: TEdit;
    EditSP: TEdit;
    EditIT: TEdit;
    EditDE: TEdit;
    EditFR: TEdit;
    EditPO: TEdit;
    Label4: TLabel;
    Label7: TLabel;
    Label8: TLabel;
    Label9: TLabel;
    Label10: TLabel;
    Label11: TLabel;
    BitBtn1: TBitBtn;
    Panel2: TPanel;
    GroupBox3: TGroupBox;
    SpeedButton1: TSpeedButton;
    RadioButton8: TRadioButton;
    RadioButton9: TRadioButton;
    RadioButton10: TRadioButton;
    RadioButton11: TRadioButton;
    RadioButton12: TRadioButton;
    RadioButton13: TRadioButton;
    procedure FormCreate(Sender: TObject);
    procedure SpinEdit1Change(Sender: TObject);
    procedure Close1Click(Sender: TObject);
    procedure FormClose(Sender: TObject; var Action: TCloseAction);
    procedure Button2Click(Sender: TObject);
    procedure Button3Click(Sender: TObject);
    procedure Button5Click(Sender: TObject);
    procedure Button4Click(Sender: TObject);
    procedure Button6Click(Sender: TObject);
    procedure Button7Click(Sender: TObject);
    procedure Button8Click(Sender: TObject);
    procedure About1Click(Sender: TObject);
    procedure Button10Click(Sender: TObject);
    procedure DBNavigator1Click(Sender: TObject; Button: TNavigateBtn);
    procedure BitBtn1Click(Sender: TObject);
    procedure EditENKeyDown(Sender: TObject; var Key: Word;
      Shift: TShiftState);
    procedure DBGrid1KeyUp(Sender: TObject; var Key: Word;
      Shift: TShiftState);
    procedure SpeedButton1Click(Sender: TObject);
    procedure DBGrid1CellClick(Column: TColumn);
  private
    { Private declarations }
   procedure ChangeLang(Lang : String);
   procedure LoadEdit;
  public
    { Public declarations }
   Dir : String;
  end;

var
  Form1: TForm1;

implementation

uses About;


{$R *.DFM}

procedure TForm1.FormCreate(Sender: TObject);
var
 i   : Integer;
begin

 {Necessary statement to configure the language table with the String}
 Dir := ExtractFilePath(ExpandFileName('GLang.Exe'));
 if Dir[Length(Dir)] <> '\' then Dir := Dir + '\';

 FicLang := 'GLang.dbf';       {Variable of F_Lang. Name of Lang Table}
 with Table1 do begin
  DatabaseName := Dir;         {Alias}
  TableName    := FicLang;
  IfExistsTable(Table1, Dir);  {procedure of F_Lang. If not Exists FicLang, Make file}
  Open;
 end;
 {End Necessary statement}

 {Miscellany}
 SpinEdit1.MaxValue := Form1.ComponentCount - 1;
 for i := 0 to Form1.ComponentCount - 1 do
  ListBox1.Items.Add(Form1.Components[i].Name);
 SpinEdit1Change(nil);
 LoadEdit;
end;

procedure TForm1.SpinEdit1Change(Sender: TObject);
var
 C : TComponent;
begin

 C := Components[SpinEdit1.Value];
 Edit1.Text := GetComponentProp(C,'Hint');

 Edit1.Text := Form1.Name;
 if C.Name <> '' then Edit2.Text := C.Name;
 if IfProperty(C,'Caption') then begin
  Edit3.Text := GetComponentProp(C, 'Caption');
 end else begin
  Edit3.Text := '';
 end;

end;

procedure TForm1.Close1Click(Sender: TObject);
begin
 Close;
end;

procedure TForm1.FormClose(Sender: TObject; var Action: TCloseAction);
begin
 Release;
end;

procedure TForm1.Button2Click(Sender: TObject);
var
 Lang : String;
begin

 {Create String of Lang}
 Button2.Cursor := crHourGlass;
 if      RadioButton1.Checked then Lang := 'EN'
 else if RadioButton2.Checked then Lang := 'SP'
 else if RadioButton3.Checked then Lang := 'IT'
 else if RadioButton4.Checked then Lang := 'DE'
 else if RadioButton5.Checked then Lang := 'FR'
 else if RadioButton6.Checked then Lang := 'PO'
 else if RadioButton7.Checked then Lang := 'ALL';

 {To capture the texts of the components // Function of F_Lang}
 Table1.DisableControls;
 DbfStringComponent(Table1, {Data table}
                    Form1, {Form of the that will be obtained the data}
                    Dir, {DatabaseName, or directory}
                    Lang, {Field of the Lang that will write in table
                           SP,IT,EN,DE,FR,PO,(ALL Alls)}
                    CheckBox1.Checked, {Write the blank string}
                    CheckBox1.Checked); {ReWrite the exists Text in GLang.Dbf}

 DbfStringComponent(Table1, FmAbout, Dir, Lang, CheckBox1.Checked, CheckBox1.Checked);

 ShowMessage('Process finish');

 Table1.EnableControls;
 Table1.Open;
 LoadEdit;
 Button2.Cursor := crDefault;
 EditEN.SetFocus;
end;

procedure TForm1.Button3Click(Sender: TObject);
begin
 Button3.Cursor := crHourGlass;
 ChangeLang('SP');
 Button3.Cursor := crDefault;
end;

procedure TForm1.Button4Click(Sender: TObject);
begin
 Button4.Cursor := crHourGlass;
 ChangeLang('IT');
 Button4.Cursor := crDefault;
end;

procedure TForm1.Button5Click(Sender: TObject);
begin
 Button5.Cursor := crHourGlass;
 ChangeLang('EN');
 Button5.Cursor := crDefault;
end;

procedure TForm1.Button6Click(Sender: TObject);
begin
 Button6.Cursor := crHourGlass;
 ChangeLang('FR');
 Button6.Cursor := crDefault;
end;

procedure TForm1.Button7Click(Sender: TObject);
begin
 Button7.Cursor := crHourGlass;
 ChangeLang('DE');
 Button7.Cursor := crDefault;
end;

procedure TForm1.Button8Click(Sender: TObject);
begin
 Button8.Cursor := crHourGlass;
 ChangeLang('PO');
 Button8.Cursor := crDefault;
end;

procedure TForm1.ChangeLang(Lang : String);
begin
 Table1.DisableControls;
 LangDbfComponent(Table1, // Data table
                  Form1,  // Form of the that will be obtained the data
                  Lang);  // Language that will catch in table. SP,IT,EN,DE,FR,PO

 LangDbfComponent(Table1, FmAbout, Lang);

 Table1.EnableControls;
 Table1.Open;
end;

procedure TForm1.About1Click(Sender: TObject);
begin
 FmAbout.ShowModal;
end;

procedure TForm1.Button10Click(Sender: TObject);
begin
 with Table1 do begin
  Close;
  Exclusive := True;
  EmptyTable;
  Exclusive := False;
  Open;
 end;
end;

procedure TForm1.LoadEdit;
begin
 with Table1 do begin
  if Eof then Exit;
  EditEN.Text := FieldByName('EN').AsString;
  EditSP.Text := FieldByName('SP').AsString;
  EditIT.Text := FieldByName('IT').AsString;
  EditDE.Text := FieldByName('DE').AsString;
  EditFR.Text := FieldByName('FR').AsString;
  EditPO.Text := FieldByName('PO').AsString;
 end;
end;

procedure TForm1.DBNavigator1Click(Sender: TObject; Button: TNavigateBtn);
begin
 LoadEdit;
end;

procedure TForm1.BitBtn1Click(Sender: TObject);
begin
 with Table1 do begin
  if not Active then Open;
  if Eof then Exit;
  Edit;
  FieldByName('EN').AsString := EditEN.Text;
  FieldByName('SP').AsString := EditSP.Text;
  FieldByName('IT').AsString := EditIT.Text;
  FieldByName('DE').AsString := EditDE.Text;
  FieldByName('FR').AsString := EditFR.Text;
  FieldByName('PO').AsString := EditPO.Text;
  Post;
  Next;
  LoadEdit;
 end;
end;

procedure TForm1.EditENKeyDown(Sender: TObject; var Key: Word;
  Shift: TShiftState);
begin
 if((Key = VK_DOWN)OR(Key = VK_UP)OR(Key = VK_NEXT)OR(Key = VK_PRIOR)) then begin
  if Key = VK_DOWN  then Table1.Next;
  if Key = VK_UP    then Table1.Prior;
  if Key = VK_NEXT  then Table1.MoveBy(4);
  if Key = VK_PRIOR then Table1.MoveBy(-4);
  LoadEdit;
 end;
end;

procedure TForm1.DBGrid1KeyUp(Sender: TObject; var Key: Word;
  Shift: TShiftState);
begin
 LoadEdit;
end;

procedure TForm1.SpeedButton1Click(Sender: TObject);
var
 Txt : String;
begin
 if      RadioButton8.Checked  then Txt := EditEN.Text
 else if RadioButton9.Checked  then Txt := EditSP.Text
 else if RadioButton10.Checked then Txt := EditIT.Text
 else if RadioButton11.Checked then Txt := EditDE.Text
 else if RadioButton12.Checked then Txt := EditFR.Text
 else if RadioButton13.Checked then Txt := EditPO.Text;

 if (Length(EditEN.Text)=0) and not RadioButton8.Checked  then EditEN.Text := Txt;
 if (Length(EditSP.Text)=0) and not RadioButton9.Checked  then EditSP.Text := Txt;
 if (Length(EditIT.Text)=0) and not RadioButton10.Checked then EditIT.Text := Txt;
 if (Length(EditDE.Text)=0) and not RadioButton11.Checked then EditDE.Text := Txt;
 if (Length(EditFR.Text)=0) and not RadioButton12.Checked then EditFR.Text := Txt;
 if (Length(EditPO.Text)=0) and not RadioButton13.Checked then EditPO.Text := Txt;

end;

procedure TForm1.DBGrid1CellClick(Column: TColumn);
begin
 LoadEdit;
end;

end.
